/*
 * AIEngine a new generation network intrusion detection system.
 *
 * Copyright (C) 2013-2022  Luis Campo Giralte
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *
 * Written by Luis Campo Giralte <luis.camp0.2009@gmail.com> 
 *
 */
#include "QuicInfo.h"

namespace aiengine {

void QuicInfo::reset() { 

	server_name.reset();
	user_agent.reset();
	matched_domain_name.reset();
}

std::ostream& operator<< (std::ostream &out, const QuicInfo &info) {
        
	if (info.server_name)
		out << " Host:" << info.server_name->name();

        if (info.user_agent)
                out << " UserAgent:" << info.user_agent->name();

	return out;
}

nlohmann::json& operator<< (nlohmann::json& out, const QuicInfo &info) {

        if (info.matched_domain_name)
                out["matchs"] = info.matched_domain_name->name();

	if (info.server_name)
		out["host"] = info.server_name->name();

	if (info.user_agent)
		out["ua"] = info.user_agent->name();

	return out;
}

} // namespace aiengine

